#ifndef    __MGRTREE_basdefH__
#define    __MGRTREE_basdefH__

#undef EndOfIncludesSection

#ifdef _VISCXX
#pragma warning (disable : 4270 4355)
#endif

#define sbool short

typedef unsigned short Ushort;

#ifndef  byte
#define	 byte	unsigned char
#endif

#ifndef  TRUE
#define  TRUE  1
#endif
#ifndef  FALSE
#define  FALSE   0
#endif
#ifndef  SUCCESS
#define  SUCCESS 0
#endif
#ifndef  FAILURE
#define  FAILURE -1
#endif

#define MG_sign(X) ((X) < 0 ? -1 : (X) == 0 ? 0 : 1)

#define MG_mod(X,N) (((X) + (N)) % (N))

#define MG_abs(X)   ((X) > 0 ? (X) : -(X))

#define MG_min(a,b)   ((a) < (b) ? (a) : (b))
#define MG_max(a,b)   ((a) < (b) ? (b) : (a))

#define MG_swap(T,A,B) { \
  T        tmp; \
  tmp = A; A = B; B = tmp; \
}

// constant array
#define MG_Ca_size(ca)      (sizeof (ca) / sizeof (ca[0]))

#define MG_isEmptyString(S) ((S) == NULL || (S)[0] == '\0')

#define MG_setZero(X) memset (&(X), 0, sizeof(X))


#if defined (_VISCXX)
  #define MG_DllImport __declspec( dllimport )
  #define MG_DllExport __declspec( dllexport )
#else
//  #error ???
#endif

#endif      /* __MGRTREE_basdefH__ */


