#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
!ifndef MgRtLib
MgRtLib=$(MAKEDIR)
#!error MgRtLib directory path name not defined!
!endif

!include $(MgRtLib)/mak/mgrtree.mak

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
xxDir = $(MgRtLib)\examapps\SegIncid

#----------------------------------------------------------------------------
#
#----------------------------------------------------------------------------
all: $(allExeObjs)

#----------------------------------------------------------------------------
#  Compile static libraries
#----------------------------------------------------------------------------
source = $(miscSrcDir)\System.cpp
target = $(xxOutDir)\System.obj
$(target) : $(source)
  $(objFromCppCmd)


#----------------------------------------------------------------------------
#  Build xx.exe for immediate tests
#----------------------------------------------------------------------------
!undef isDLL

xxExeObjs = \
             $(xxOutDir)\xx.obj \
             $(xxOutDir)\SegList.obj \
             $(xxOutDir)\SegRtSet.obj \
             $(xxOutDir)\SegIncid.obj \

libExeObjs = \
           $(xxOutDir)\System.obj \
           $(MgRtLib)\lib\MgRtree.lib \

allExeObjs = $(libExeObjs) $(xxExeObjs)

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
source = $(xxDir)\xx.cpp
target = $(xxOutDir)\xx.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\SegList.cpp
target = $(xxOutDir)\SegList.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\SegRtSet.cpp
target = $(xxOutDir)\SegRtSet.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\SegIncid.cpp
target = $(xxOutDir)\SegIncid.obj
$(target) : $(source)
  $(objFromCppCmd)

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
exeFileName_ = $(xxOutDir)\xx.exe
!ifdef DEBUG
exeFileName = $(exeFileName_)
!else
exeFileName = $(ReleaseBinDir)\SegIncid.exe
!endif

$(exeFileName_)         : $(allExeObjs)
  $(VcLinkCmd) @<<$(xxOutDir)\link_exe.cmd
  -nologo
  $(allExeObjs)
<<keep

#----------------------------------------------------------------------------
#     Copy release to the 'bin' directory
#----------------------------------------------------------------------------
!ifndef DEBUG
source = $(exeFileName_)
target = $(exeFileName)
$(target) : $(source)
  $(copyCmd)

!endif

#----------------------------------------------------------------------------
#     Copy dll to xxOutDir
#----------------------------------------------------------------------------
xxDllFileName = $(xxOutDir)\MgRtree.dll
source = $(MgRtLib)\src\MgRtree\$(outSubDir)\MgRtree.dll
target = $(xxDllFileName)
$(target) : $(source)
  $(copyCmd)

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
all: $(exeFileName) $(xxDllFileName)


#!message end reached
