/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "SegIncid.h"

/*------------------------------------------------------------------------- o
     private global variables
o -------------------------------------------------------------------------*/



/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
static void
printUsage ()
{
  printf ("\nSegment Incidences Detector\n");
  printf (" (C) 2002-2003 Ondrej Pavlata\n");
  printf ("\nUsage: segincid <input file name>\n");
  printf ("\nAssumed print format of a single segment:\n"
           "  printf (\"(%%d,%%d),(%%d,%%d)\\n\","
           " start.x, start.y, end.x, end.y);\n");
  printf ("Possible line comments start with #\n");
  printf ("Demonstration data files are located in testdata directory.\n");
  printf ("\n");
}

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
static void
test ()
{
  int numSeconds = time (NULL);
  printf ("Test1/%d:\n", numSeconds);
  printUsage ();
}


/*------------------------------------------------------------------------- o
      MAIN
o -------------------------------------------------------------------------*/
int
main (
int       argc,    /* => */
char **   argv)    /* => */
{
  if ( argc == 1 ) {
    printUsage ();
    return 0;
  }
  if ( argc == 2 && strcmp (argv[1], "-t") == 0 ) {
    SegIncidSpotter::processAll ("..\\..\\testdata\\SegList0.txt");
    return 0;
  }
  if ( argc == 2 ) {
    SegIncidSpotter::processAll (argv[1]);
    return 0;
  }
  return  0;
}

