#----------------------------------------------------------------------------
#     DllMain
#----------------------------------------------------------------------------
initDllObjs = $(xxOutDir)\dllentry.obj

source = $(miscSrcDir)\dllentry.c
target = $(xxOutDir)\dllentry.obj
$(target) : $(source)
  $(objFromCppCmd)

#----------------------------------------------------------------------------
#     Command for building dll file
#----------------------------------------------------------------------------
DllLinkCmd = $(VcBinDir)\link
dllNtLibs  = $(usedVcLibs)

DLM_BASE_ADDRESS = 0x1c000000
DLLENTRY = @12

dllFileName_ = $(xxOutDir)\$(dllName).dll
libFileName_ = $(xxOutDir)\$(dllName).lib

!ifdef DEBUG
dllFileName = $(dllFileName_)
libFileName = $(libFileName_)
!else
dllFileName = $(ReleaseBinDir)\$(dllName).dll
libFileName = $(ReleaseLibDir)\$(dllName).lib
!endif

$(dllFileName_):    $(allDllObjs)
  $(DllLinkCmd) @<<$(xxOutDir)\link_dll.cmd
  -nologo
  -out:$@
  -entry:_DllMainCRTStartup$(DLLENTRY)
  -dll
  -subsystem:windows
!ifdef DEBUG
  -pdb:none
  -debug
!endif
  $(allDllObjs)
  $(dllNtLibs)
<<keep

#----------------------------------------------------------------------------
#     Copy release to the 'bin' and 'lib' directories
#----------------------------------------------------------------------------
!ifndef DEBUG
source = $(dllFileName_)
target = $(dllFileName)
$(target) : $(source)
  $(copyCmd)

source = $(libFileName_)
target = $(libFileName)
$(target) : $(source)
  $(copyCmd)

!endif
