/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
#include <assert.h>
#include <string.h>
#include <stdio.h>

#include <sys/timeb.h>

#include <mgrtree/System.h>

#undef EndOfIncludesSection
/*------------------------------------------------------------------------- o
       private definitions
o -------------------------------------------------------------------------*/

/*------------------------------------------------------------------------- o
       static global variables
o -------------------------------------------------------------------------*/
static double  g_time = 0.0;

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
double
MgSystem::curTime ()
{
  struct _timeb  ct;
  _ftime (&ct);
  double  seconds = ct.time;
  double  milliseconds = ct.millitm;
  return  seconds + milliseconds / 1000.0;
}

void
MgSystem::startTime ()
{
  g_time = curTime ();
}

double
MgSystem::difTime ()
{
  return  curTime () - g_time;
}

void
MgSystem::printDifTime ()
{
  printf ("\nElapsed time: %.2f\n", difTime());
}


